# ![NCC](assets/icon/ncc@32px.png "NCC") Nosial Code Compiler

[![wakatime](https://wakatime.com/badge/user/bc15cc8e-c9b9-4c11-bad9-3e3cfacf01e4/project/273bc06f-12e7-43d7-824d-40a78b02aada.svg)](https://wakatime.com/badge/user/bc15cc8e-c9b9-4c11-bad9-3e3cfacf01e4/project/273bc06f-12e7-43d7-824d-40a78b02aada)

Nosial Code Compiler is a package compiler, manager & installer for PHP. Allowing you to install and manage multiple
versions of php packages on your system that your PHP programs/projects can share and use. Additionally, ncc also allows
you to create a redistributable package of your PHP program/project in the form of a `.ncc` binary package file.


## Features

- [x] Package Manager
- [x] Support for repositories such as GitHub, GitLab, GitTea and Packagist
- [x] Package compiler
- [x] Execution Handler
- [x] Import System (*No need for autoloaders!*)


## Dependencies

- PHP 8.0 or higher
- php-mbstring extension
- php-zip extension
- php-mbcrypt extension
- php-ctype extension
- php-curl extension


## Documentation

Extensive documentation for ncc can be found on at [DOCUMENTATION.md](DOCUMENTATION.md), explaining how from how to
build and install ncc to how to use it, it is highly recommended that you read the documentation before using ncc.


## Bugs and issues

If you encounter any bugs or issues with ncc, please report them on the [issue tracker](https://git.n64.cc/nosial/ncc/-/issues).


## Changelog

The changelog for ncc can be found in the [CHANGELOG.md](CHANGELOG.md) file.



## Repository Mirrors

The official repository for ncc is hosted on [n64](https://git.n64.cc/nosial/ncc); however, you can also find
mirrors of the repository mirrored on different platforms, including 
community-powered mirrors. (more to come)

 - [git.it-kuny.ch](https://git.it-kuny.ch)
 - [git.martinvlba.eu](https://git.martinvlba.eu/Nosial/ncc)
 - [github.com](https://github.com/Nosial/ncc)


# Contributing

We welcome contributions to ncc! If you have an idea for how to improve the project, please don't hesitate to reach out.
There are many ways to contribute, and we appreciate all forms of support.

For more information on how to contribute, please read the [CONTRIBUTING.md](CONTRIBUTING.md) file.



# Code of Conduct

We are committed to maintaining a welcoming and inclusive environment for all contributors. Please read and follow our
[Code of Conduct](CODE_OF_CONDUCT.md).


# Authors

- Zi Xing Narrakas (netkas) <[netkas@n64.cc](mailto:netkas@64.cc)>


# Special Thanks

- Marc Gutt (mgutt) <[marc@gutt.it](mailto:marc@gutt.it)>
- Debusschère Alexandre ([debuss](https://github.com/debuss))
- badPointer <[https://git.n64.cc/badPointer](https://git.n64.cc/badPointer)>
- Cybersecbyte <[https://git.n64.cc/Cybersecbyte](https://git.n64.cc/Cybersecbyte)>


# Copyright

- Copyright (c) 2022-2023, Nosial—All Rights Reserved


# Licenses

ncc is licensed under the MIT License, see [LICENSE](LICENSE) for more information.
Multiple licenses for the open-source components used in this project can be found at [LICENSE](LICENSES)